"""
This type stub file was generated by pyright.
"""

import unittest

"""
Side effects are avoided using two techniques:

- Low level OS requests (keyboard._os_keyboard) are mocked out by rewriting
the functions at that namespace. This includes a list of dummy keys.
- Events are pumped manually by the main test class, and accepted events
are tested against expected values.

Fake user events are appended to `input_events`, passed through
keyboard,_listener.direct_callback, then, if accepted, appended to
`output_events`. Fake OS events (keyboard.press) are processed
and added to `output_events` immediately, mimicking real functionality.
"""
dummy_keys = ...
def make_event(event_type, name, scan_code=..., time=...): # -> KeyboardEvent:
    ...

input_events = ...
output_events = ...
def send_instant_event(event): # -> None:
    ...

d_a = ...
u_a = ...
du_a = ...
d_b = ...
u_b = ...
du_b = ...
d_c = ...
u_c = ...
du_c = ...
d_ctrl = ...
u_ctrl = ...
du_ctrl = ...
d_shift = ...
u_shift = ...
du_shift = ...
d_alt = ...
u_alt = ...
du_alt = ...
du_backspace = ...
du_capslock = ...
d_space = ...
u_space = ...
du_space = ...
trigger = ...
triggered_event = ...
class TestKeyboard(unittest.TestCase):
    def tearDown(self): # -> None:
        ...
    
    def setUp(self): # -> None:
        ...
    
    def do(self, manual_events, expected=...): # -> None:
        ...
    
    def test_event_json(self): # -> None:
        ...
    
    def test_is_modifier_name(self): # -> None:
        ...
    
    def test_is_modifier_scan_code(self): # -> None:
        ...
    
    def test_key_to_scan_codes_brute(self): # -> None:
        ...
    
    def test_key_to_scan_code_from_scan_code(self): # -> None:
        ...
    
    def test_key_to_scan_code_from_letter(self): # -> None:
        ...
    
    def test_key_to_scan_code_from_normalized(self): # -> None:
        ...
    
    def test_key_to_scan_code_from_sided_modifier(self): # -> None:
        ...
    
    def test_key_to_scan_code_underscores(self): # -> None:
        ...
    
    def test_key_to_scan_code_error_none(self): # -> None:
        ...
    
    def test_key_to_scan_code_error_empty(self): # -> None:
        ...
    
    def test_key_to_scan_code_error_other(self): # -> None:
        ...
    
    def test_key_to_scan_code_list(self): # -> None:
        ...
    
    def test_key_to_scan_code_empty(self): # -> None:
        ...
    
    def test_key_to_scan_code_duplicated(self): # -> None:
        ...
    
    def test_parse_hotkey_simple(self): # -> None:
        ...
    
    def test_parse_hotkey_separators(self): # -> None:
        ...
    
    def test_parse_hotkey_keys(self): # -> None:
        ...
    
    def test_parse_hotkey_simple_steps(self): # -> None:
        ...
    
    def test_parse_hotkey_steps(self): # -> None:
        ...
    
    def test_parse_hotkey_example(self): # -> None:
        ...
    
    def test_parse_hotkey_list_scan_codes(self): # -> None:
        ...
    
    def test_parse_hotkey_deep_list_scan_codes(self): # -> None:
        ...
    
    def test_parse_hotkey_list_names(self): # -> None:
        ...
    
    def test_is_pressed_none(self): # -> None:
        ...
    
    def test_is_pressed_true(self): # -> None:
        ...
    
    def test_is_pressed_true_scan_code_true(self): # -> None:
        ...
    
    def test_is_pressed_true_scan_code_false(self): # -> None:
        ...
    
    def test_is_pressed_true_scan_code_invalid(self): # -> None:
        ...
    
    def test_is_pressed_false(self): # -> None:
        ...
    
    def test_is_pressed_hotkey_true(self): # -> None:
        ...
    
    def test_is_pressed_hotkey_false(self): # -> None:
        ...
    
    def test_is_pressed_multi_step_fail(self): # -> None:
        ...
    
    def test_send_single_press_release(self): # -> None:
        ...
    
    def test_send_single_press(self): # -> None:
        ...
    
    def test_send_single_release(self): # -> None:
        ...
    
    def test_send_single_none(self): # -> None:
        ...
    
    def test_press(self): # -> None:
        ...
    
    def test_release(self): # -> None:
        ...
    
    def test_press_and_release(self): # -> None:
        ...
    
    def test_send_modifier_press_release(self): # -> None:
        ...
    
    def test_send_modifiers_release(self): # -> None:
        ...
    
    def test_call_later(self): # -> None:
        ...
    
    def test_hook_nonblocking(self): # -> None:
        ...
    
    def test_hook_blocking(self): # -> None:
        ...
    
    def test_on_press_nonblocking(self): # -> None:
        ...
    
    def test_on_press_blocking(self): # -> None:
        ...
    
    def test_on_release(self): # -> None:
        ...
    
    def test_hook_key_invalid(self): # -> None:
        ...
    
    def test_hook_key_nonblocking(self): # -> None:
        ...
    
    def test_hook_key_blocking(self): # -> None:
        ...
    
    def test_on_press_key_nonblocking(self): # -> None:
        ...
    
    def test_on_press_key_blocking(self): # -> None:
        ...
    
    def test_on_release_key(self): # -> None:
        ...
    
    def test_block_key(self): # -> None:
        ...
    
    def test_block_key_ambiguous(self): # -> None:
        ...
    
    def test_remap_key_simple(self): # -> None:
        ...
    
    def test_remap_key_ambiguous(self): # -> None:
        ...
    
    def test_remap_key_multiple(self): # -> None:
        ...
    
    def test_stash_state(self): # -> None:
        ...
    
    def test_restore_state(self): # -> None:
        ...
    
    def test_restore_modifieres(self): # -> None:
        ...
    
    def test_write_simple(self): # -> None:
        ...
    
    def test_write_multiple(self): # -> None:
        ...
    
    def test_write_modifiers(self): # -> None:
        ...
    
    def test_write_stash_restore(self): # -> None:
        ...
    
    def test_write_multiple(self): # -> None:
        ...
    
    def test_write_unicode_explicit(self): # -> None:
        ...
    
    def test_write_unicode_fallback(self): # -> None:
        ...
    
    def test_start_stop_recording(self): # -> None:
        ...
    
    def test_stop_recording_error(self): # -> None:
        ...
    
    def test_record(self): # -> None:
        ...
    
    def test_play_nodelay(self): # -> None:
        ...
    
    def test_play_stash(self): # -> None:
        ...
    
    def test_play_delay(self): # -> None:
        ...
    
    def test_get_typed_strings_simple(self): # -> None:
        ...
    
    def test_get_typed_strings_backspace(self): # -> None:
        ...
    
    def test_get_typed_strings_shift(self): # -> None:
        ...
    
    def test_get_typed_strings_all(self): # -> None:
        ...
    
    def test_get_hotkey_name_simple(self): # -> None:
        ...
    
    def test_get_hotkey_name_modifiers(self): # -> None:
        ...
    
    def test_get_hotkey_name_normalize(self): # -> None:
        ...
    
    def test_get_hotkey_name_plus(self): # -> None:
        ...
    
    def test_get_hotkey_name_duplicated(self): # -> None:
        ...
    
    def test_get_hotkey_name_full(self): # -> None:
        ...
    
    def test_get_hotkey_name_multiple(self): # -> None:
        ...
    
    def test_get_hotkey_name_from_pressed(self): # -> None:
        ...
    
    def test_read_hotkey(self): # -> None:
        ...
    
    def test_read_event(self): # -> None:
        ...
    
    def test_read_key(self): # -> None:
        ...
    
    def test_wait_infinite(self): # -> None:
        ...
    
    def test_wait_until_success(self): # -> None:
        ...
    
    def test_wait_until_fail(self): # -> None:
        ...
    
    def test_add_hotkey_single_step_suppress_allow(self): # -> None:
        ...
    
    def test_add_hotkey_single_step_suppress_args_allow(self): # -> None:
        ...
    
    def test_add_hotkey_single_step_suppress_single(self): # -> None:
        ...
    
    def test_add_hotkey_single_step_suppress_removed(self): # -> None:
        ...
    
    def test_add_hotkey_single_step_suppress_removed(self): # -> None:
        ...
    
    def test_remove_hotkey_internal(self): # -> None:
        ...
    
    def test_remove_hotkey_internal_multistep_start(self): # -> None:
        ...
    
    def test_remove_hotkey_internal_multistep_end(self): # -> None:
        ...
    
    def test_add_hotkey_single_step_suppress_with_modifiers(self): # -> None:
        ...
    
    def test_add_hotkey_single_step_suppress_with_modifiers_fail_unrelated_modifier(self): # -> None:
        ...
    
    def test_add_hotkey_single_step_suppress_with_modifiers_fail_unrelated_key(self): # -> None:
        ...
    
    def test_add_hotkey_single_step_suppress_with_modifiers_unrelated_key(self): # -> None:
        ...
    
    def test_add_hotkey_single_step_suppress_with_modifiers_release(self): # -> None:
        ...
    
    def test_add_hotkey_single_step_suppress_with_modifiers_out_of_order(self): # -> None:
        ...
    
    def test_add_hotkey_single_step_suppress_with_modifiers_repeated(self): # -> None:
        ...
    
    def test_add_hotkey_single_step_suppress_with_modifiers_release(self): # -> None:
        ...
    
    def test_add_hotkey_single_step_suppress_with_modifier_superset_release(self): # -> None:
        ...
    
    def test_add_hotkey_single_step_suppress_with_modifier_superset(self): # -> None:
        ...
    
    def test_add_hotkey_single_step_timeout(self): # -> None:
        ...
    
    def test_add_hotkey_multi_step_first_timeout(self): # -> None:
        ...
    
    def test_add_hotkey_multi_step_last_timeout(self): # -> None:
        ...
    
    def test_add_hotkey_multi_step_success_timeout(self): # -> None:
        ...
    
    def test_add_hotkey_multi_step_suffix_timeout(self): # -> None:
        ...
    
    def test_add_hotkey_multi_step_allow(self): # -> None:
        ...
    
    def test_add_hotkey_single_step_nonsuppress(self): # -> None:
        ...
    
    def test_add_hotkey_single_step_nonsuppress_repeated(self): # -> None:
        ...
    
    def test_add_hotkey_single_step_nosuppress_with_modifiers_out_of_order(self): # -> None:
        ...
    
    def test_add_hotkey_single_step_suppress_regression_1(self): # -> None:
        ...
    
    def test_remap_hotkey_single(self): # -> None:
        ...
    
    def test_remap_hotkey_complex_dst(self): # -> None:
        ...
    
    def test_remap_hotkey_modifiers(self): # -> None:
        ...
    
    def test_remap_hotkey_modifiers_repeat(self): # -> None:
        ...
    
    def test_remap_hotkey_modifiers_state(self): # -> None:
        ...
    
    def test_remap_hotkey_release_incomplete(self): # -> None:
        ...
    
    def test_remap_hotkey_release_complete(self): # -> None:
        ...
    
    def test_parse_hotkey_combinations_scan_code(self): # -> None:
        ...
    
    def test_parse_hotkey_combinations_single(self): # -> None:
        ...
    
    def test_parse_hotkey_combinations_single_modifier(self): # -> None:
        ...
    
    def test_parse_hotkey_combinations_single_modifiers(self): # -> None:
        ...
    
    def test_parse_hotkey_combinations_multi(self): # -> None:
        ...
    
    def test_parse_hotkey_combinations_multi_modifier(self): # -> None:
        ...
    
    def test_parse_hotkey_combinations_list_list(self): # -> None:
        ...
    
    def test_parse_hotkey_combinations_fail_empty(self): # -> None:
        ...
    
    def test_add_hotkey_multistep_suppress_incomplete(self): # -> None:
        ...
    
    def test_add_hotkey_multistep_suppress_incomplete(self): # -> None:
        ...
    
    def test_add_hotkey_multistep_suppress_modifier(self): # -> None:
        ...
    
    def test_add_hotkey_multistep_suppress_fail(self): # -> None:
        ...
    
    def test_add_hotkey_multistep_suppress_three_steps(self): # -> None:
        ...
    
    def test_add_hotkey_multistep_suppress_repeated_prefix(self): # -> None:
        ...
    
    def test_add_hotkey_multistep_suppress_repeated_key(self): # -> None:
        ...
    
    def test_add_hotkey_multi_step_suppress_regression_1(self): # -> None:
        ...
    
    def test_add_hotkey_multi_step_suppress_replays(self): # -> None:
        ...
    
    def test_add_word_listener_success(self): # -> None:
        ...
    
    def test_add_word_listener_no_trigger_fail(self): # -> None:
        ...
    
    def test_add_word_listener_timeout_fail(self): # -> None:
        ...
    
    def test_duplicated_word_listener(self): # -> None:
        ...
    
    def test_add_word_listener_remove(self): # -> None:
        ...
    
    def test_add_word_listener_suffix_success(self): # -> None:
        ...
    
    def test_add_word_listener_suffix_fail(self): # -> None:
        ...
    


if __name__ == '__main__':
    ...
