"""
This type stub file was generated by pyright.
"""

import ctypes
from ctypes import Structure, c_uint8

"""
This is the Windows backend for keyboard events, and is implemented by
invoking the Win32 API through the ctypes module. This is error prone
and can introduce very unpythonic failure modes, such as segfaults and
low level memory leaks. But it is also dependency-free, very performant
well documented on Microsoft's website and scattered examples.

# TODO:
- Keypad numbers still print as numbers even when numlock is off.
- No way to specify if user wants a keypad key or not in `map_char`.
"""
LPMSG = ...
ULONG_PTR = ...
kernel32 = ...
GetModuleHandleW = ...
user32 = ...
VK_PACKET = ...
INPUT_MOUSE = ...
INPUT_KEYBOARD = ...
INPUT_HARDWARE = ...
KEYEVENTF_KEYUP = ...
KEYEVENTF_UNICODE = ...
class KBDLLHOOKSTRUCT(Structure):
    _fields_ = ...


class MOUSEINPUT(ctypes.Structure):
    _fields_ = ...


class KEYBDINPUT(ctypes.Structure):
    _fields_ = ...


class HARDWAREINPUT(ctypes.Structure):
    _fields_ = ...


class _INPUTunion(ctypes.Union):
    _fields_ = ...


class INPUT(ctypes.Structure):
    _fields_ = ...


LowLevelKeyboardProc = ...
SetWindowsHookEx = ...
CallNextHookEx = ...
UnhookWindowsHookEx = ...
GetMessage = ...
TranslateMessage = ...
DispatchMessage = ...
keyboard_state_type = c_uint8 * 256
GetKeyboardState = ...
GetKeyNameText = ...
MapVirtualKey = ...
ToUnicode = ...
SendInput = ...
MAPVK_VK_TO_CHAR = ...
MAPVK_VK_TO_VSC = ...
MAPVK_VSC_TO_VK = ...
MAPVK_VK_TO_VSC_EX = ...
MAPVK_VSC_TO_VK_EX = ...
VkKeyScan = ...
LLKHF_INJECTED = ...
WM_KEYDOWN = ...
WM_KEYUP = ...
WM_SYSKEYDOWN = ...
WM_SYSKEYUP = ...
keyboard_event_types = ...
official_virtual_keys = ...
tables_lock = ...
to_name = ...
from_name = ...
scan_code_to_vk = ...
distinct_modifiers = ...
name_buffer = ...
unicode_buffer = ...
keyboard_state = keyboard_state_type()
def get_event_names(scan_code, vk, is_extended, modifiers):
    ...

init = ...
keypad_keys = ...
shift_is_pressed = ...
altgr_is_pressed = ...
ignore_next_right_alt = ...
shift_vks = ...
def prepare_intercept(callback): # -> None:
    """
    Registers a Windows low level keyboard hook. The provided callback will
    be invoked for each high-level keyboard event, and is expected to return
    True if the key event should be passed to the next program, or False if
    the event is to be blocked.

    No event is processed until the Windows messages are pumped (see
    start_intercept).
    """
    ...

def listen(callback): # -> None:
    ...

def map_name(name): # -> Generator[tuple[Unknown, Unknown], None, None]:
    ...

def press(code): # -> None:
    ...

def release(code): # -> None:
    ...

def type_unicode(character): # -> None:
    ...

if __name__ == '__main__':
    ...
