"""
This type stub file was generated by pyright.
"""

import platform as _platform
from ._generic import GenericListener as _GenericListener

if _platform.system() == 'Windows':
    ...
else:
    ...
_pressed_events = ...
class _MouseListener(_GenericListener):
    def init(self): # -> None:
        ...
    
    def pre_process_event(self, event): # -> Literal[True]:
        ...
    
    def listen(self): # -> None:
        ...
    


_listener = ...
def is_pressed(button=...): # -> bool:
    """ Returns True if the given button is currently pressed. """
    ...

def press(button=...): # -> None:
    """ Presses the given button (but doesn't release). """
    ...

def release(button=...): # -> None:
    """ Releases the given button. """
    ...

def click(button=...): # -> None:
    """ Sends a click with the given button. """
    ...

def double_click(button=...): # -> None:
    """ Sends a double click with the given button. """
    ...

def right_click(): # -> None:
    """ Sends a right click with the given button. """
    ...

def wheel(delta=...): # -> None:
    """ Scrolls the wheel `delta` clicks. Sign indicates direction. """
    ...

def move(x, y, absolute=..., duration=...): # -> None:
    """
    Moves the mouse. If `absolute`, to position (x, y), otherwise move relative
    to the current position. If `duration` is non-zero, animates the movement.
    """
    ...

def drag(start_x, start_y, end_x, end_y, absolute=..., duration=...): # -> None:
    """
    Holds the left mouse button, moving from start to end position, then
    releases. `absolute` and `duration` are parameters regarding the mouse
    movement.
    """
    ...

def on_button(callback, args=..., buttons=..., types=...): # -> (event: Unknown) -> None:
    """ Invokes `callback` with `args` when the specified event happens. """
    ...

def on_click(callback, args=...): # -> (event: Unknown) -> None:
    """ Invokes `callback` with `args` when the left button is clicked. """
    ...

def on_double_click(callback, args=...): # -> (event: Unknown) -> None:
    """
    Invokes `callback` with `args` when the left button is double clicked.
    """
    ...

def on_right_click(callback, args=...): # -> (event: Unknown) -> None:
    """ Invokes `callback` with `args` when the right button is clicked. """
    ...

def on_middle_click(callback, args=...): # -> (event: Unknown) -> None:
    """ Invokes `callback` with `args` when the middle button is clicked. """
    ...

def wait(button=..., target_types=...): # -> None:
    """
    Blocks program execution until the given button performs an event.
    """
    ...

def get_position(): # -> tuple[Any, Any] | tuple[int, int] | tuple[Unknown, Unknown]:
    """ Returns the (x, y) mouse position. """
    ...

def hook(callback):
    """
    Installs a global listener on all available mouses, invoking `callback`
    each time it is moved, a key status changes or the wheel is spun. A mouse
    event is passed as argument, with type either `mouse.ButtonEvent`,
    `mouse.WheelEvent` or `mouse.MoveEvent`.
    
    Returns the given callback for easier development.
    """
    ...

def unhook(callback): # -> None:
    """
    Removes a previously installed hook.
    """
    ...

def unhook_all(): # -> None:
    """
    Removes all hooks registered by this application. Note this may include
    hooks installed by high level functions, such as `record`.
    """
    ...

def record(button=..., target_types=...): # -> list[Unknown]:
    """
    Records all mouse events until the user presses the given button.
    Then returns the list of events recorded. Pairs well with `play(events)`.

    Note: this is a blocking function.
    Note: for more details on the mouse hook and events see `hook`.
    """
    ...

def play(events, speed_factor=..., include_clicks=..., include_moves=..., include_wheel=...):
    """
    Plays a sequence of recorded events, maintaining the relative time
    intervals. If speed_factor is <= 0 then the actions are replayed as fast
    as the OS allows. Pairs well with `record()`.

    The parameters `include_*` define if events of that type should be inluded
    in the replay or ignored.
    """
    ...

replay = ...
hold = ...
if __name__ == '__main__':
    ...
